#include <OneWire.h>

#define pin 11           //Порт для подключения iButton
const int buttonPin = 6; //Порт кнопки. *** ВНИМАНИЕ!!! Реакция на изменение порта кнопки ИНВЕРТИРОВАНО! Включена подтяжка и порт надо ЗАМЫКАТЬ на "ЗЕМЛЮ", а не на питание (доп.подтягивающий резистор на питание можно поставить)
const int ledPin = 13;   //Порт светодиода

int buttonState = 0;
int writeflag = 0;
int readflag = 0;
int val = 0;
byte addr[8];
byte buff[8];
byte ReadID[8] = { 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x2F }; // "Универсальный" ключ. Прошивается последовательность 01:FF:FF:FF:FF:FF:FF:2F
OneWire ibutton (pin); // Пин D11 для подлючения iButton (Data)

void setup() {
  pinMode(ledPin, OUTPUT);
  pinMode(buttonPin, INPUT);
  digitalWrite(buttonPin, HIGH); //Включили подтяжку
  Serial.begin(115200);
}

void loop() {

  buttonState = digitalRead(buttonPin);
  if (buttonState == LOW) {  //Реакция на изменение порта кнопки ИНВЕРТИРОВАНО! Включена подтяжка и порт надо ЗАМЫКАТЬ на "ЗЕМЛЮ". 
    readflag = 1;
    writeflag = 1;
    digitalWrite(ledPin, HIGH);
    val++;
    if (val > 6) val = 6;
    Serial.print(val);
    delay(500);
  }
  else {
    val = 0;
  }


  if (!ibutton.search (addr)) {
    ibutton.reset_search();
    delay(50);
    if (val <= 5) return;
    val = 0;
  }

if (Serial.read() == 'w'){ writeflag = 1; digitalWrite(ledPin, HIGH);}

  digitalWrite(ledPin, HIGH);
  delay(50);

  for (byte x = 0; x < 8; x++) {
    if(addr[x]<16)Serial.print("0");
    Serial.print(addr[x], HEX);
    if ((readflag == 0) and (writeflag!=1)) {
      ReadID[x] = (addr[x]);
    }
    if(x<7) Serial.print(":");
  }

  byte crc; // Проверка контрольной суммы
  crc = ibutton.crc8(addr, 7);
  Serial.print("  CRC: ");
  Serial.println(crc, HEX);
  digitalWrite(ledPin, LOW);

  if (writeflag == 1) {
    ibutton.skip(); ibutton.reset(); ibutton.write(0x33);
  
  //  Serial.print("  ID before write: ");
    for (byte x = 0; x < 8; x++) {
      int readd = ibutton.read();
      buff[x]=readd;
  //    if(readd<16)Serial.print(0);
  //    Serial.print(readd, HEX);
  //    if(x<7)Serial.print(":");
      }
  
    // send reset
    ibutton.skip();
    ibutton.reset();
    // send 0xD1
    ibutton.write(0xD1);
    // send logical 0
    digitalWrite(pin, LOW); pinMode(pin, OUTPUT); delayMicroseconds(60);
    pinMode(pin, INPUT); digitalWrite(pin, HIGH); delay(10);

    Serial.print('\n');
    Serial.print("  Writing iButton ID:\n    ");
    byte newID[8] = { (ReadID[0]), (ReadID[1]), (ReadID[2]), (ReadID[3]), (ReadID[4]), (ReadID[5]), (ReadID[6]), (ReadID[7]) };
    ibutton.skip();
    ibutton.reset();
    ibutton.write(0xD5);
    for (byte x = 0; x < 8; x++) {
      writeByte(newID[x]);
      Serial.print('*');
    }
    Serial.print('\n');
    ibutton.reset();
    // send 0xD1
    ibutton.write(0xD1);
    //send logical 1
    digitalWrite(pin, LOW); pinMode(pin, OUTPUT); delayMicroseconds(10);
    pinMode(pin, INPUT); digitalWrite(pin, HIGH); delay(10);
    writeflag = 0;
    readflag = 0;
    digitalWrite(ledPin, LOW);

    Serial.print('\n');
    Serial.print("  ID before write: ");
    for (byte x = 0; x < 8; x++) {
      int readd = buff[x];
    if(readd<16)Serial.print(0);
    Serial.print(readd, HEX);
    if(x<7)Serial.print(":");
    }
    Serial.print('\n');
    Serial.print("  ID for write:    ");
    for (byte x = 0; x < 8; x++) {
      int readd = newID[x];
    if(readd<16)Serial.print(0);
    Serial.print(readd, HEX);
    if(x<7)Serial.print(":");
    }

    Serial.print('\n');
      Serial.print("  ID after write:  ");
         ibutton.skip(); ibutton.reset(); ibutton.write(0x33);
  
  //  Serial.print("  ID before write: ");
    for (byte x = 0; x < 8; x++) {
      int readd = ibutton.read();
  //    buff[x]=readd;
      if(readd<16)Serial.print(0);
      Serial.print(readd, HEX);
      if(x<7)Serial.print(":");
      }
      Serial.print('\n');
      Serial.print('\n');

    

  }
}

int writeByte(byte data) {
  int data_bit;
  for (data_bit = 0; data_bit < 8; data_bit++) {
    if (data & 1) {
      digitalWrite(pin, LOW); pinMode(pin, OUTPUT);
      delayMicroseconds(60);
      pinMode(pin, INPUT); digitalWrite(pin, HIGH);
      delay(10);
    } else {
      digitalWrite(pin, LOW); pinMode(pin, OUTPUT);
      pinMode(pin, INPUT); digitalWrite(pin, HIGH);
      delay(10);
    }
    data = data >> 1;
  }
  return 0;
}
